import 'dart:async';
import 'dart:io';

import 'package:flutter/cupertino.dart';
import 'package:flutter/foundation.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

class EhsureScanner {
  static const MethodChannel _channel = const MethodChannel('ehsure_scanner');

  static Future<String> getScanResult (BuildContext context) async {
    if (Platform.isIOS) {
      String scanResult = await Navigator.push(context, MaterialPageRoute(builder: (context) {
        return _IosScanView();
      }));
      return scanResult;
    } else {
      final String scanValue = await _channel.invokeMethod('scan');
      print(scanValue);
      return scanValue;
    }
  }
}

class _IosScanView extends StatefulWidget {
  @override
  __IosScanViewState createState() => __IosScanViewState();
}

class __IosScanViewState extends State<_IosScanView> {
  @override
  void initState() {
    super.initState();
    handleChannel();
  }
  handleChannel() {
    final channel = MethodChannel("ehsure_scanner");
    channel.setMethodCallHandler((handler) {
      if (handler.method == "scanResult") {
        Navigator.of(context).pop(handler.arguments.toString());
      }
      return null;
    });
  }
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(title: Text("二维码扫描"),),
      body: UiKitView(
        viewType: 'ehsure_scanner_plugin',
        gestureRecognizers: <Factory<OneSequenceGestureRecognizer>>[
          new Factory<OneSequenceGestureRecognizer>(
                () => new EagerGestureRecognizer(),
          ),
        ].toSet(),
      ),
    );
  }
}
